---
title: Traversing an HTML table with JavaScript and DOM Interfaces
slug: >-
  Web/API/Document_Object_Model/Traversing_an_HTML_table_with_JavaScript_and_DOM_Interfaces
tags:
  - API
  - DOM
  - Guide
  - HTML
  - JavaScript
---
<p>{{DefaultAPISidebar("DOM")}}</p>

<h2 id="Introduction">Introduction</h2>

<p>This article is an overview of some powerful, fundamental DOM level 1 methods and how to use them from JavaScript. You will learn how to create, access and control, and remove HTML elements dynamically. The DOM methods presented here are not specific to HTML; they also apply to XML. The demonstrations provided here will work fine in any modern browser, including all versions of Firefox and IE 5+.</p>

<div class="notecard note">
<p>The DOM methods presented here are part of the Document Object Model (Core) level 1 specification. DOM level 1 includes both methods for generic document access and manipulation (DOM 1 Core) as well as methods specific to HTML documents (DOM 1 HTML).</p>
</div>

<h2 id="Overview_of_Sample1.html">Example: Creating an HTML table dynamically (<code>Sample1.html</code>)</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html; notranslate">&lt;input type="button" value="Generate a table." onclick="generate_table()"&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js; notranslate">function generate_table() {
  // get the reference for the body
  var body = document.getElementsByTagName("body")[0];

  // creates a &lt;table&gt; element and a &lt;tbody&gt; element
  var tbl = document.createElement("table");
  var tblBody = document.createElement("tbody");

  // creating all cells
  for (var i = 0; i &lt; 2; i++) {
    // creates a table row
    var row = document.createElement("tr");

    for (var j = 0; j &lt; 2; j++) {
      // Create a &lt;td&gt; element and a text node, make the text
      // node the contents of the &lt;td&gt;, and put the &lt;td&gt; at
      // the end of the table row
      var cell = document.createElement("td");
      var cellText = document.createTextNode("cell in row "+i+", column "+j);
      cell.appendChild(cellText);
      row.appendChild(cell);
    }

    // add the row to the end of the table body
    tblBody.appendChild(row);
  }

  // put the &lt;tbody&gt; in the &lt;table&gt;
  tbl.appendChild(tblBody);
  // appends &lt;table&gt; into &lt;body&gt;
  body.appendChild(tbl);
  // sets the border attribute of tbl to 2;
  tbl.setAttribute("border", "2");
}</pre>

<p>{{ EmbedLiveSample('Overview_of_Sample1.html') }}</p>

<p>Note the order in which we created the elements and the text node:</p>

<ol>
 <li>First we created the <code>&lt;table&gt;</code> element.</li>
 <li>Next, we created the <code>&lt;tbody&gt;</code> element, which is a child of the <code>&lt;table&gt;</code> element.</li>
 <li>Next, we used a loop to create the <code>&lt;tr&gt;</code> elements, which are children of the <code>&lt;tbody&gt;</code> element.</li>
 <li>For each <code>&lt;tr&gt;</code> element, we used a loop to create the <code>&lt;td&gt;</code> elements, which are children of <code>&lt;tr&gt;</code> elements.</li>
 <li>For each <code>&lt;td&gt;</code> element, we then created the text node with the table cell's text.</li>
</ol>

<p>Once we have created the <code>&lt;table&gt;</code>, <code>&lt;tbody&gt;</code>, <code>&lt;tr&gt;</code>, and <code>&lt;td&gt;</code> elements, and then the text node, we then append each object to its parent in the opposite order:</p>

<ol>
 <li>First, we attach each text node to its parent <code>&lt;td&gt;</code> element using

  <pre class="notranslate">cell.appendChild(cellText);</pre>
 </li>
 <li>Next, we attach each <code>&lt;td&gt;</code> element to its parent <code>&lt;tr&gt;</code> element using
  <pre class="notranslate">row.appendChild(cell);</pre>
 </li>
 <li>Next, we attach each <code>&lt;tr&gt;</code> element to the parent <code>&lt;tbody&gt;</code> element using
  <pre class="notranslate">tblBody.appendChild(row);</pre>
 </li>
 <li>Next, we attach the <code>&lt;tbody&gt;</code> element to its parent <code>&lt;table&gt;</code> element using
  <pre class="notranslate">tbl.appendChild(tblBody);</pre>
 </li>
 <li>Next, we attach the <code>&lt;table&gt;</code> element to its parent <code>&lt;body&gt;</code> element using
  <pre class="notranslate">body.appendChild(tbl);</pre>
 </li>
</ol>

<p>Remember this technique. You will use it frequently in programming for the W3C DOM. First, you create elements from the top down; then you attach the children to the parents from the bottom up.</p>

<p>Here's the HTML markup generated by the JavaScript code:</p>

<pre class="notranslate">...
&lt;table border="2"&gt;
&lt;tbody&gt;
&lt;tr&gt;&lt;td&gt;cell is row 0 column 0&lt;/td&gt;&lt;td&gt;cell is row 0 column 1&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;cell is row 1 column 0&lt;/td&gt;&lt;td&gt;cell is row 1 column 1&lt;/td&gt;&lt;/tr&gt;
&lt;/tbody&gt;
&lt;/table&gt;
...
</pre>

<p>Here's the DOM object tree generated by the code for the <code>&lt;table&gt;</code> element and its child elements:</p>

<p><img alt="Image:sample1-tabledom.jpg" src="/@api/deki/files/833/=Sample1-tabledom.jpg"></p>

<p>You can build this table and its internal child elements by using just a few DOM methods. Remember to keep in mind the tree model for the structures you are planning to create; this will make it easier to write the necessary code. In the <code>&lt;table&gt;</code> tree of Figure 1 the element <code>&lt;table&gt;</code> has one child: the element <code>&lt;tbody&gt;</code>. <code>&lt;tbody&gt;</code> has two children. Each <code>&lt;tbody&gt;</code>'s child (<code>&lt;tr&gt;</code>) has two children (<code>&lt;td&gt;</code>). Finally, each <code>&lt;td&gt;</code> has one child: a text node.</p>

<h2 id="Setting_background_of_a_paragraph">Example: Setting the background color of a paragraph</h2>

<p><code>getElementsByTagName(tagNameValue)</code> is a method available in any DOM {{domxref("Element")}} or the root {{domxref("Document")}} element. When called, it returns an array with all of the element's descendants matching the tag name. The first element of the list is located at position <code>[0]</code> in the array.</p>

<h3 id="HTML_2">HTML</h3>

<pre class="brush: html; notranslate">&lt;body&gt;
  &lt;input type="button" value="Set paragraph background color" onclick="set_background()"&gt;
  &lt;p&gt;hi&lt;/p&gt;
  &lt;p&gt;hello&lt;/p&gt;
&lt;/body&gt;</pre>

<h3 id="JavaScript_2">JavaScript</h3>

<pre class="brush: js; notranslate">function set_background() {
  // get a list of all the body elements (there will only be one),
  // and then select the zeroth (or first) such element
  myBody = document.getElementsByTagName("body")[0];

  // now, get all the p elements that are descendants of the body
  myBodyElements = myBody.getElementsByTagName("p");

  // get the second item of the list of p elements
  myP = myBodyElements[1];
  myP.style.background = "rgb(255,0,0)";
}</pre>

<p>{{ EmbedLiveSample('Setting_background_of_a_paragraph') }}</p>

<p>In this example, we set the <code>myP</code> variable to the DOM object for the second <code>p</code> element inside the body:</p>

<ol>
 <li>First, we get a list of all the body elements via
  <pre class="notranslate">myBody = document.getElementsByTagName("body")[0]</pre>
  Since there is only one <code>body</code> element in any valid HTML document, this list will have only one item, which we retrieve by selecting the first element in that list using <code>[0]</code>.</li>
 <li>Next, we get all the <code>p</code> elements that are descendants of the <code>body</code>:
  <pre class="notranslate">myBodyElements = myBody.getElementsByTagName("p");</pre>
 </li>
 <li>Finally, we get the second item from the list of <code>p</code> elements via
  <pre class="notranslate">myP = myBodyElements[1];</pre>
 </li>
</ol>

<p><img alt="Image:sample2a2.jpg" src="/@api/deki/files/834/=Sample2a2.jpg"></p>

<p>Once you have gotten the DOM object for an HTML element, you can set its properties. For example, if you want to set the style background color property, you just add:</p>

<pre class="notranslate">myP.style.background = "rgb(255,0,0)";
// setting inline STYLE attribute
</pre>

<h3 id="Creating_TextNodes_with_document.createTextNode.28.22...22.29">Creating TextNodes with document.createTextNode("..")</h3>

<p>Use the document object to invoke the <code>createTextNode</code> method and create your text node. You just need to pass the text content. The return value is an object that represents the text node.</p>

<pre class="notranslate">myTextNode = document.createTextNode("world");
</pre>

<p>This means that you have created a node of the type <code>TEXT_NODE</code> (a piece of text) whose text data is <code>"world"</code>, and <code>myTextNode</code> is your reference to this node object. To insert this text into your HTML page, you need to make this text node a child of some other node element.</p>

<h3 id="Inserting_Elements_with_appendChild.28...29">Inserting Elements with appendChild(..)</h3>

<p>So, by calling <code>myP.appendChild(<var>node_element</var>)</code>, you are making the element a new child of the second <code>&lt;p&gt;</code> element.</p>

<pre class="notranslate">myP.appendChild(myTextNode);
</pre>

<p>After testing this sample, note that the words hello and world are together: helloworld. So visually, when you see the HTML page it seems like the two text nodes hello and world are a single node, but remember that in the document model, there are two nodes. The second node is a new node of type <code>TEXT_NODE</code>, and it is the second child of the second <code>&lt;p&gt;</code> tag. The following figure shows the recently created Text Node object inside the document tree.</p>

<p><img alt="Image:sample2b2.jpg" src="/@api/deki/files/835/=Sample2b2.jpg"></p>

<div class="notecard note">
<p><code>createTextNode()</code> and <code>appendChild()</code> is a simple way to include white space between the words hello and world. Another important note is that the <code>appendChild</code> method will append the child after the last child, just like the word world has been added after the word hello. So if you want to append a Text Node between hello and world, you will need to use <code>insertBefore</code> instead of <code>appendChild</code>.</p>
</div>

<h3 id="Creating_New_Elements_with_the_document_object_and_the_createElement.28...29_method">Creating New Elements with the document object and the createElement(..) method</h3>

<p>You can create new HTML elements or any other element you want with <code>createElement</code>. For example, if you want to create a new <code>&lt;p&gt;</code> element as a child of the <code>&lt;body&gt;</code> element, you can use the <code>myBody</code> in the previous example and append a new element node. To create a node call <code>document.createElement("tagname")</code>. For example:</p>

<pre class="notranslate">myNewPTAGnode = document.createElement("p");
myBody.appendChild(myNewPTAGnode);
</pre>

<p><img alt="Image:sample2c.jpg" src="/@api/deki/files/836/=Sample2c.jpg"></p>

<h3 id="Removing_nodes_with_the_removeChild.28...29_method">Removing nodes with the removeChild(..) method</h3>

<p>Nodes can be removed. The following code removes text node <code>myTextNode</code> (containing the word "world") from the second <code>&lt;p&gt;</code> element, <code>myP</code>.</p>

<pre class="notranslate">myP.removeChild(myTextNode);
</pre>

<p>Text node <code>myTextNode</code> (containing the word "world") still exists. The following code attaches <code>myTextNode</code> to the recently created <code>&lt;p&gt;</code> element, <code>myNewPTAGnode</code>.</p>

<pre class="notranslate">myNewPTAGnode.appendChild(myTextNode);
</pre>

<p>The final state for the modified object tree looks like this:</p>

<p><img alt="Image:sample2d.jpg" src="/@api/deki/files/837/=Sample2d.jpg"></p>

<h2 id="Creating_a_table_dynamically_.28back_to_Sample1.html.29">Creating a table dynamically (back to Sample1.html)</h2>

<p>For the rest of this article we will continue working with sample1.html. The following figure shows the table object tree structure for the table created in the sample.</p>

<h3 id="Reviewing_the_HTML_Table_structure">Reviewing the HTML Table structure</h3>

<p><img alt="Image:sample1-tabledom.jpg" src="/@api/deki/files/833/=Sample1-tabledom.jpg"></p>

<h3 id="Creating_element_nodes_and_inserting_them_into_the_document_tree">Creating element nodes and inserting them into the document tree</h3>

<p>The basic steps to create the table in sample1.html are:</p>

<ul>
 <li>Get the body object (first item of the document object).</li>
 <li>Create all the elements.</li>
 <li>Finally, append each child according to the table structure (as in the above figure). The following source code is a commented version for the sample1.html.</li>
</ul>

<div class="notecard note">
<p>At the end of the <code>start</code> function, there is a new line of code. The table's <code>border</code> property was set using another DOM method, <code>setAttribute()</code>. <code>setAttribute()</code> has two arguments: the attribute name and the attribute value. You can set any attribute of any element using the <code>setAttribute</code> method.</p>
</div>

<pre class="brush: html; notranslate">&lt;head&gt;
&lt;title&gt;Sample code - Traversing an HTML Table with JavaScript and DOM Interfaces&lt;/title&gt;
&lt;script&gt;
    function start() {
        // get the reference for the body
        var mybody = document.getElementsByTagName("body")[0];

        // creates &lt;table&gt; and &lt;tbody&gt; elements
        mytable = document.createElement("table");
        mytablebody = document.createElement("tbody");

        // creating all cells
        for(var j = 0; j &lt; 3; j++) {
            // creates a &lt;tr&gt; element
            mycurrent_row = document.createElement("tr");

            for(var i = 0; i &lt; 4; i++) {
                // creates a &lt;td&gt; element
                mycurrent_cell = document.createElement("td");
                // creates a Text Node
                currenttext = document.createTextNode("cell is row " + j + ", column " + i);
                // appends the Text Node we created into the cell &lt;td&gt;
                mycurrent_cell.appendChild(currenttext);
                // appends the cell &lt;td&gt; into the row &lt;tr&gt;
                mycurrent_row.appendChild(mycurrent_cell);
            }
            // appends the row &lt;tr&gt; into &lt;tbody&gt;
            mytablebody.appendChild(mycurrent_row);
        }

        // appends &lt;tbody&gt; into &lt;table&gt;
        mytable.appendChild(mytablebody);
        // appends &lt;table&gt; into &lt;body&gt;
        mybody.appendChild(mytable);
        // sets the border attribute of mytable to 2;
        mytable.setAttribute("border","2");
    }
&lt;/script&gt;
&lt;/head&gt;
&lt;body onload="start()"&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>

<h2 id="Manipulating_the_table_with_DOM_and_CSS">Manipulating the table with DOM and CSS</h2>

<h3 id="Getting_a_text_node_from_the_table">Getting a text node from the table</h3>

<p>This example introduces two new DOM attributes. First it uses the <code>childNodes</code> attribute to get the list of child nodes of mycel. The <code>childNodes</code> list includes all child nodes, regardless of what their name or type is. Like <code>getElementsByTagName()</code>, it returns a list of nodes.</p>

<p>The differences are that (a) <code>getElementsByTagName()</code> only returns elements of the specified tag name; and (b) <code>getElementsByTagName()</code> returns descendants at any level, not just immediate children.</p>

<p>Once you have the returned list, use <code>[x]</code> method to retrieve the desired child item. This example stores in myceltext the text node of the second cell in the second row of the table.</p>

<p>Then, to display the results in this example, it creates a new text node whose content is the data of <code>myceltext</code>, and appends it as a child of the <code>&lt;body&gt;</code> element.</p>

<div class="notecard note">
<p>If your object is a text node, you can use the data attribute and retrieve the text content of the node.</p>
</div>

<pre class="brush: js; notranslate">mybody = document.getElementsByTagName("body")[0];
mytable = mybody.getElementsByTagName("table")[0];
mytablebody = mytable.getElementsByTagName("tbody")[0];
myrow = mytablebody.getElementsByTagName("tr")[1];
mycel = myrow.getElementsByTagName("td")[1];

// first item element of the childNodes list of mycel
myceltext=mycel.childNodes[0];

// content of currenttext is the data content of myceltext
currenttext=document.createTextNode(myceltext.data);
mybody.appendChild(currenttext);
</pre>

<h3 id="Getting_an_attribute_value">Getting an attribute value</h3>

<p>At the end of sample1 there is a call to <code>setAttribute</code> on the <code>mytable</code> object. This call was used to set the border property of the table. To retrieve the value of the attribute, use the <code>getAttribute</code> method:</p>

<pre class="brush: js; notranslate">mytable.getAttribute("border");</pre>

<h3 id="Hiding_a_column_by_changing_style_properties">Hiding a column by changing style properties</h3>

<p>Once you have the object in your JavaScript variable, you can set <code>style</code> properties directly. The following code is a modified version of sample1.html in which each cell of the second column is hidden and each cell of the first column is changed to have a red background. Note that the <code>style</code> property was set directly.</p>

<pre class="brush: html notranslate">&lt;html&gt;
&lt;body onload="start()"&gt;
&lt;/body&gt;
&lt;script&gt;
    function start() {
       var mybody = document.getElementsByTagName("body")[0];
       mytable = document.createElement("table");
       mytablebody = document.createElement("tbody");

       for(var row = 0; row &lt; 2; row++) {
           mycurrent_row=document.createElement("tr");
           for(var col = 0; col &lt; 2; col++) {
               mycurrent_cell = document.createElement("td");
               currenttext = document.createTextNode("cell is: " + row + col);
               mycurrent_cell.appendChild(currenttext);
               mycurrent_row.appendChild(mycurrent_cell);
               // set the cell background color
               // if the column is 0. If the column is 1 hide the cell
               if (col === 0) {
                   mycurrent_cell.style.background = "rgb(255,0,0)";
               } else {
                   mycurrent_cell.style.display = "none";
               }
           }
           mytablebody.appendChild(mycurrent_row);
       }
       mytable.appendChild(mytablebody);
       mybody.appendChild(mytable);
    }
&lt;/script&gt;
&lt;/html&gt;</pre>

<h4 id="Original_Document_Information">Original Document Information</h4>

<dl>
 <dt>Author(s)</dt>
 <dd>Marcio Galli</dd>
 <dt>Migrated from</dt>
 <dd>http://web.archive.org/web/20000815054125/http://mozilla.org/docs/dom/technote/tn-dom-table/</dd>
</dl>
